//! \file    NewProjectWindow.cpp
//! \brief   Implementation of the NewProject window for visual_YAO.
//! \version 2010/06/25 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane.

/*
  Nom du Fichier: NewProjectWindow.cpp
  Nom de classe: NewProjectWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "include/NewProjectWindow.hpp"

using namespace std;
//using namespace yao;


//! \class OrderWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Order window for visual_YAO.

/*********************************************************************************************************************************/
NewProjectWindow::NewProjectWindow(QWorkspace &espace, QDialog *parent) : QDialog(parent) {

	setupUi(this);
	//m_newProjectWindowProjectName = aProjectName;
	//m_newProjectWindowProjectName = "cool, la référence!";
	m_newProjectPathButton->setIcon(QIcon("Images/icons/openfile.png"));
	m_linePath->setText(QDir::currentPath() + "/projects");
	//setFixedWidth(baseSize().width() + 765);
	
	//m_orderModel	= new QStandardItemModel(0, 5);

	connect(m_newProjectQuitButton, SIGNAL(clicked()), this, SLOT(close()));// Pour la fermeture de fenetre.
	connect(m_newProjectPathButton, SIGNAL(clicked()), this, SLOT(openPathWindow()));
	connect(m_newProjectHelpButton, SIGNAL(clicked()), this, SLOT(helpMessage()));// Pour la fermeture de fenetre.

	connect(m_newProjectCreateButton, SIGNAL(clicked()), this, SLOT(createProjectDirectory())); //Pour la création du répertoire. 
	connect(this, SIGNAL(projectDone()), this, SLOT(close())); //Pour la création du répertoire. 
	//m_newProjectHelpButton->setShortcut(tr("Ctrl+A"));
	
	 this->exec();
}
/*********************************************************************************************************************************/
NewProjectWindow::NewProjectWindow(QDialog *parent) : QDialog(parent) {

	setupUi(this);
	//setWindowTitle(getProjectName());
	//m_newProjectWindowProjectName = aProjectName;
	//m_newProjectWindowProjectName = "cool, la référence!";
	m_newProjectPathButton->setIcon(QIcon("Images/icons/openfile.png"));
	m_linePath->setText(QDir::currentPath() + "/projects");
	//setFixedWidth(baseSize().width() + 765);
	
	//m_orderModel	= new QStandardItemModel(0, 5);

	connect(m_newProjectQuitButton, SIGNAL(clicked()), this, SLOT(close()));// Pour la fermeture de fenetre.
	connect(m_newProjectPathButton, SIGNAL(clicked()), this, SLOT(openPathWindow()));
	connect(m_newProjectHelpButton, SIGNAL(clicked()), this, SLOT(helpMessage()));// Pour la fermeture de fenetre.

	connect(m_newProjectCreateButton, SIGNAL(clicked()), this, SLOT(createProjectDirectory())); //Pour la création du répertoire. 
	connect(this, SIGNAL(projectDone()), this, SLOT(close())); //Pour la création du répertoire. 
	//m_newProjectHelpButton->setShortcut(tr("Ctrl+A"));
	
	 this->exec();
}
/*********************************************************************************************************************************/
void NewProjectWindow::openPathWindow() {
  
    QString dir = QFileDialog::getExistingDirectory(this, tr("Recherche d'un fichier"), "/home", QFileDialog::ShowDirsOnly |
                                                                                               QFileDialog::DontResolveSymlinks);
  
          if (!dir.isEmpty()) m_linePath->setText(dir);
  
 }

/********************************************************************************************************************************/
void NewProjectWindow::helpMessage() {
 
	 QMessageBox msgBox;
		msgBox.setWindowTitle("Aide sur la création d'un nouveau projet.");
		msgBox.setText("L'utilisateur est invité à remplir les différents champs.<br> Le nom du projet doit commencer par une lettre (a-z) sans accent ou un chiffre. Les autres caractères ne sont pas acceptés.");
		//msgBox.setInformativeText("<p> Cliquez sur <b>ok</b> pour fermer cette fenêtre.");
                           //msgBox.setStandardButtons(QMessageBox::Yes);
		msgBox.setDefaultButton(QMessageBox::Yes);
 
		msgBox.exec();
 }

/*********************************************************************************************************************************/
void NewProjectWindow::createProjectDirectory() {
	try 
		{
			setProjectName(m_lineDirName->text().toStdString()); //Fonction permettant d'initialiser le nom du projet.
			setProjectPath(m_linePath->text().toStdString()); //Fonction permettant d'initialiser le chemin du projet.
			//theHeaderList.push_back(getProjectName() + ".h");

			if (m_lineDirName->text().isEmpty()) //Contrôle à faire si le champ réservé au nom du projet est délaissé vide.
				{
					QMessageBox::critical(this, "Erreur", "Le nom du projet n'est pas spécifié! Réessayez en remplissant correctement le champ correspondant. ");
					return; // Arrêt de la méthode
				}         
         
			string projectNameControl;

			projectNameControl = getProjectName();

			QMessageBox msgBox;
				msgBox.setWindowTitle("Erreur de saisie.");
				msgBox.setText("Les caractères saisis ne sont pas conformes.");
				//msgBox.setStandardButtons(QMessageBox::Yes);
				msgBox.setDefaultButton(QMessageBox::Yes);

			if (projectNameControl[0] == '&' || projectNameControl[0] == '@' || projectNameControl[0] == '^'
                                 || projectNameControl[0] == '(' || projectNameControl[0] == ')' || projectNameControl[0] == '.'
                                 || projectNameControl[0] == '{' || projectNameControl[0] == '}' || projectNameControl[0] == '$'
                                 || projectNameControl[0] == '#' || projectNameControl[0] == '~' || projectNameControl[0] == '\''
                                 || projectNameControl[0] == '*' || projectNameControl[0] == '=' || projectNameControl[0] == '?'
                                 || projectNameControl[0] == '!' || projectNameControl[0] == ':' || projectNameControl[0] == '-'
                                 || projectNameControl[0] == '_' || projectNameControl[0] == '[' || projectNameControl[0] == ']'
                                 || projectNameControl[0] == '%' || projectNameControl[0] == ',' || projectNameControl[0] == ';'
                                 || projectNameControl[0] == '"' || projectNameControl[0] == '|' )

                         {
                                 msgBox.exec();
                                 m_lineDirName->clear();
                                 return ;
                         }

			for(unsigned int i=1; i < projectNameControl.size(); i++)
				if (projectNameControl[i] == '&' || projectNameControl[i] == '@' || projectNameControl[i] == '^'
					|| projectNameControl[i] == '(' || projectNameControl[i] == ')' || projectNameControl[i] == '.'
					|| projectNameControl[i] == '{' || projectNameControl[i] == '}' || projectNameControl[i] == '$'
					|| projectNameControl[i] == '#' || projectNameControl[i] == '~' || projectNameControl[i] == '\''
					|| projectNameControl[i] == '*' || projectNameControl[i] == '=' || projectNameControl[i] == '?'
					|| projectNameControl[i] == '!' || projectNameControl[i] == ':' || projectNameControl[i] == '-'
					|| projectNameControl[i] == '/' || projectNameControl[i] == '[' || projectNameControl[i] == ']'
					|| projectNameControl[i] == '%' || projectNameControl[i] == ',' || projectNameControl[i] == ';'
					|| projectNameControl[i] == '"' || projectNameControl[i] == '|' )

                        {
                                msgBox.exec();
                                m_lineDirName->clear();
                                return ;
                        }

		     QDir rep(QString(getProjectPath().c_str()));
			 if (!rep.exists(QString(getProjectName().c_str())))  // c_str is used for having the Qt string form (this form is QString)
			   { 
				rep.mkdir(QString(getProjectName().c_str()));
				createFile("", ".d");
				generateDefaultHFile();
				createFile(ligneInfos->toPlainText().toStdString(), ".txt");
        //fv->appelActualiser(); //Permet de mettre à jour automatiquement la liste des fichiers visibles dans filesviewer.
				QMessageBox msgBox;
					msgBox.setWindowTitle("Opération réussie.");
					msgBox.setText("Le projet <b> <i>\"" + QString(getProjectName().c_str()) + "\"</i></b> a été crée avec succès.");
					msgBox.setDefaultButton(QMessageBox::Yes);
					msgBox.exec();
                //activateToolBarButtons();
				emit projectDone();
			 }
			else {
			   QMessageBox::about(this, tr("Nouveau projet"), tr("<p>Le projet existe! <p> Donnez s'il vous plait un autre nom."));
				 m_lineDirName->clear();
				 m_lineDirName->setCursor(Qt::IBeamCursor);
				return;

			}

       // emit WindowTitleChanged();
  }
  catch (...)
	{
		QMessageBox::critical(this, "Erreur", "Erreur dans la creation d'un nouveau projet.");
	}
}

 /************************************** Implementation of the method createFile(string data, string extension) ************************************/
void NewProjectWindow::createFile(string data, string extension) {
 
     string filename = getProjectName() + extension;
     string filepath = getProjectPath() +  "/" + getProjectName() +  "/" + getProjectName() + extension; // Respectivement le chemin, le répertoire et le fichier dans le repertoire.
           ofstream h_file(filepath.c_str(), ios::out | ios::binary | ios::trunc);
           if(!h_file.is_open())
                         throw ofstream::failure("couldn't create " + filename);
                 h_file << data << endl;
 
     h_file.close();
   }

/************************************* Implementation of the method createFile(string data, string extension) ************************************/
/*void NewProjectWindow::createFile(string data, string extension) {
  
	string filename = getProjectName() + extension;
	string filepath = getProjectPath() +  "/" + getProjectName() +  "/" + getProjectName() + extension; // Respectivement le chemin, le répertoire et l     e fichier dans le repertoire.
	ofstream h_file(filepath.c_str(), ios::out | ios::binary | ios::trunc);
	if(!h_file.is_open())
		throw ofstream::failure("couldn't create " + filename);
	h_file << data << endl;
  
	h_file.close();
}
*/

/*************************************** Implementation of the method generateDefaultHFile() ******************************************************/
void NewProjectWindow::generateDefaultHFile() 
{
     
	// The hat file genereted automatically.
	//string filename = "projects/" + getNomProjet().toStdString() + "/" + getNomProjet().toStdString() + ".h";

	string filename = getProjectName() + ".h" ;     
	//string filepath = getProjectPath() + ".h" ; 
	string filepath = getProjectPath() +  "/" + getProjectName() +  "/" + getProjectName() + ".h";     
 
	ofstream hat(filepath.c_str(), ios::out | ios::binary | ios::trunc);
            if(!hat.is_open())
		  throw ofstream::failure("couldn't create " + filename);
     
	hat << "/*****************************************************************************************************" << endl;
	hat << "* Fichier chapeau généré automatiquement par Visual YAO." << endl;
	hat << "* Le fichier chapeau permet à l'utilisateur d'intervenir pendant l'exécution de l'application YAO." << endl;
	hat << "* On peut déclarer des variables globales et des fonctions spécifiques de l'application définies    *" << endl;
	hat << "* par l'utilisateur dans le fichier description (dans ce cas là on ajoute aussi les prototypes.     *" << endl;
	hat << "* Dans ce fichier il faut toujours avoir les fonctions spécifiques mais obligatoires pour YAO       *" << endl 
	<< "* (celles de ce squelette).                                                                         *" << endl
	<< "*****************************************************************************************************/" << endl;


	hat << "// DECLARATION DE VARIABLES GLOBALES (si nécessaire) :" << endl
            << endl
            << endl
            << endl
	<< "// PROTOTYPAGE (si nécessaire) :" << endl
		<< endl
		<< endl
		<< endl
	<< "// FONCTIONS SPECIFIQUES (mais obligatoires pour YAO) :" << endl
	<< "// Permet si besoin de prendre la main des le début de l'application." << endl
	<< "void appli_start(int argc, char *argv[]){ }" << endl
	<< endl
	<< "// Intervenir avant une itération." << endl
	<< "void before_it(int nit){ }" << endl
	<< endl
	<< "// Fonction de coût spécifique." << endl
	<< "void cost_function(int pdt){ }" << endl
	  << endl
	  << "// Fonction d'ajustement spécifique." << endl
	  << "void adjust_target(){ }" << endl
	<< endl
	<< "// Intervenir après une itération." << endl
	  << "void after_it(int nit){ }" << endl
	<< endl
	<< "// Intervenir avant le forward." << endl
	<< endl
	<< "// Intervenir avant le forward." << endl
	<< "void forward_before(int ctrp){ }" << endl
	<< endl
	<< "// Intervenir après le forward." << endl
		<< "void forward_after(int ctrp){ }" << endl
	<< endl
	<< "// Intervenir avant le backward." << endl
		<< "void backward_before(int ctrp){ }" << endl
	<< endl
	<< "// Intervenir après le backward." << endl
		<< "void backward_after(int ctrp){ }" << endl
	<< endl
	<< "// Permet d'agir lorsqu'on appelle les fonctions d'I/O de YAO." << endl
		<< "short select_io(int indic, char *nmod, int sortie, int iaxe, int jaxe, int kaxe, int pdt, YREAL *val){ }" << endl
	<< endl
	<< endl
	<< endl
	<< "// FONCTIONS SPECIFIQUES de l'application (si nécessaire) :" << endl
	<< endl;

     hat.close();
}

/***********************************************************************/
void NewProjectWindow::setProjectName(string aProjectName) {

	m_newProjectWindowProjectName = aProjectName;	
}
/***********************************************************************/
 string NewProjectWindow::getProjectName() {
	
	return m_newProjectWindowProjectName; 
}
/*******************************************************************************************************************/
void NewProjectWindow::setProjectPath(string aProjectPath) {
	
	m_newProjectWindowProjectPath = aProjectPath;	

}
/***********************************************************************/
 string NewProjectWindow::getProjectPath() {
	
	return m_newProjectWindowProjectPath; 
}
/***********************************************************************/
