//! \file    OrderWindow.cpp
//! \brief   Implementation of the OrderWindow window for visual_YAO.
//! \version 2010/11/03 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane.

/*
  Nom du Fichier: OrderWindow.cpp
  Nom de classe: OrderWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "include/OrderWindow.hpp"

using namespace std;
using namespace yao;
//! \class OrderWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Order window for visual_YAO.

/***************************************** Implementation of the Construtor OrderWindow() *************************************************/
OrderWindow::OrderWindow(Table <Trajectory> *aTrajectoryTable, Table <Space> *aSpaceTable, Table <Operator> *anOperatorTable, Table <Modul> *aModulTable,  Table <Connection> *aConnectionTable, Table <Order> *anOrderTable, vector <string> *anOrderTokens, QWidget *parent) : stateOfSpaceintrajEndCheckBox(false), QWidget(parent), m_localOrder(m_localModulTable), m_localTrajectoryTable(aTrajectoryTable), m_localSpaceTable(aSpaceTable), m_localOperaTable(anOperatorTable), m_localModulTable(aModulTable), m_localConnectionTable(aConnectionTable), m_localOrderTable(anOrderTable), localTokens(anOrderTokens) {

	setupUi(this);
	
	/*
	setFixedWidth(baseSize().width() + 765);
	m_comboTrajName->insertItem(0, "");
	
	for (Table<Trajectory>::iterator it = m_localTrajectoryTable->begin(); it != m_localTrajectoryTable->end(); it++) {
		m_comboTrajName->insertItem(1, QString(it->getName().c_str()));	
	}	

	for (Table<Space>::iterator it = m_localSpaceTable->begin(); it != m_localSpaceTable->end(); it++) {
		
		m_comboSpaceOrOperaName->insertItem(1, QString(it->getName().c_str()));	
		m_comboSpaceName->insertItem(1, QString(it->getName().c_str()));	
	}
	*/

	//m_orderModel			= new QStandardItemModel(0, 5);
	//m_choiceComboBox		= new QComboBox;
		m_choiceComboBox->addItem(tr("modinspace"));		
		m_choiceComboBox->addItem(tr("spaceintraj"));		

	//m_modinspaceRadioButton		= new QRadioButton("modinspace");
	//m_spaceintrajRadioButton	= new QRadioButton("spaceintraj");	
		misw 	= new ModinspaceWindow(m_localModulTable, m_localSpaceTable, m_localOperaTable, m_localOrderTable, &m_localOrder,localTokens); 
		sitw 	= new SpaceintrajWindow(m_localTrajectoryTable, m_localSpaceTable, m_localOperaTable, m_localOrderTable, &m_localOrder, localTokens);
		//sitw->show(); 
	
	//horizontalLayout		= new QHBoxLayout;
	//	horizontalLayout->addWidget(m_modinspaceRadioButton);
	//	horizontalLayout->addWidget(m_spaceintrajRadioButton);

	stackedLayout 			= new QStackedLayout(m_mainFrame);
		 stackedLayout->addWidget(misw);
		 stackedLayout->addWidget(sitw);
	
	
	//mainLayout = new QVBoxLayout;
		//mainLayout->addWidget(m_choiceComboBox);
	//	mainLayout->addLayout(stackedLayout); 
	//setLayout(mainLayout);
	
	
	//setFixedWidth(baseSize().width() + 765);
	//resize(645, 540);
	connect(m_choiceComboBox, SIGNAL(activated(int )), stackedLayout, SLOT(setCurrentIndex(int )));
	connect(m_helpButton, SIGNAL(clicked()), this, SLOT(theOrderHelp()));
	//connect(m_validationButton, SIGNAL(clicked()), this, SLOT(close()));
	connect(m_quitButton, SIGNAL(clicked()), this, SLOT(close()));

	connect(sitw, SIGNAL(theEndSignal(bool)), this, SLOT(initializeTheCheckBox(bool)));

}
/*********************************************************************/
void OrderWindow::initializeTheCheckBox(bool) {
	
	stateOfSpaceintrajEndCheckBox = true;
	cout << "coché" << endl;
}
/*********************************************************************/
void OrderWindow::theOrderHelp() {
	
	QMessageBox::about(this, tr("Aide sur la directive Order"), ("Order permet d'indiquer l'enchainement, l'ordre de calcul dans YAO. Il existent deux cas d'utilisation: modinspace et spaceintraj. Les étapes à suivre sont les suivantes: <br> Faire un choix dans le champ deroulant \"modinspace/spaceintraj\"; <br> Pour le cas de modinspace, indiquer d'abord les coordonnées (possibilité de répeter les operations), ensuite les modules (possibilité de faire plusieurs opérations) et enfin préciser la condition d'arrêt.<br> Pour le cas de spaceintraj, choisir respectivement la trajectoire, les espaces et cocher la case \"Fin de saisie\"."));

}
/**************************************************** Implementation of cloveEvent() method. ***********************************************/
void OrderWindow::closeEvent(QCloseEvent *event) {

	emit orderWindowIsClosed(10);
}

/***********************************************************************/

/***********************************************************************/
/***********************************************************************/
