/*!
 * \file    ConnectionWindow.hpp
 * \brief   Ctin class for visual_YAO.
 * \version 2010/07/07 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane.
 */

#ifndef CTIN_HPP
#define CTIN_HPP

#include "../../ui_connectionwindow.h"
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Connection.hpp"
#include "../../../YAOObjects/Constant.hpp"
#include "../../../YAOObjects/Modul.hpp"
#include <QTextCodec>
#include <QFileDialog>
#include <QMessageBox>
#include <QStringList>
#include <QStandardItemModel>
#include <string>
#include <iostream>
#include <fstream>

//using namespace yao;
using namespace std;
//using namespace yao;

/*!
 * \class ConnectionWindow
 * \brief Ctin class for visual_YAO.
 */

class ConnectionWindow : public QWidget, public Ui::ConnectionWindow {


	Q_OBJECT

	public :
         	       /*!
			*  \brief Constructor
			*  Constructor of the class ConnectionWindow
			*  \param parent : initialized at zero.
			*/

			ConnectionWindow(yao::Table <yao::Connection> *aConnectionTable, yao::Table <yao::Modul> *aModulTable,  yao::Table <yao::Constant> *aConstantTable, QWidget *parent=0);
			QStringList getDataCtin(); /*!< This function returns the connexion's data. */
			void toInitialize();
			const int toInt(const string& s);

	private slots:       /*!< Functions called after a click. */

			void ctinHelp(); 
			void addCtinRow();
			void deleteCtinRow();
			void activateInIntervalle(QString aString );
			void activateOutIntervalle(QString aString );
			void activateIIntervalle(QString aString );
			void activateJIntervalle(QString aString );
			void activateKIntervalle(QString aString );
			void activateTIntervalle(QString aString );

	signals:
			void ctinWindowIsClosed(int anInt);		
			void ctinRowIsAdded(bool aBool);

	protected:
			void closeEvent(QCloseEvent *event);

	private :
			QModelIndex index;
			QStringList CtinData;
			QStandardItemModel *m_ctinModel;
			yao::Connection m_localConnection;
			yao::Table <yao::Modul> *m_localModulTable;
			yao::Table <yao::Connection> *m_localConnectionTable;
			yao::Table <yao::Constant> *m_localConstantTable;
			int cpt;		    
};
#endif // CTIN_HPP
