/*
Copyright or © or Copr. Abdouramane MAYAKI

mail of the author: mayakiyerima@yahoo.fr

This software is a framework for variational data assimilation in
numerical models.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

/*!
 * \file    ConstantWindow.hpp
 * \brief   ConstantWindow class for visual_YAO.
 * \version 2010/05/12 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane.
 */
#ifndef DEFVALWINDOW_HPP
#define DEFVALWINDOW_HPP

#include "HatNameWindow.hpp"
#include "MainWindowController.hpp"
#include "../../ui_constantwindow.h"

class QTimer;

class ConstantWindow : public QWidget, Ui::ConstantWindow {

	Q_OBJECT

	public :
            /*!
             *  \brief Constructor
             *
             *  Constructor of the class SpaceWindow
             *
             *  \param  Table<Constant> theConstantTable
             */   
         
                ConstantWindow(yao::Table<yao::Constant> *aConstantTable, std::vector <std::string> *aHeaderList, MainWindowController *mwc, QWidget *parent=0);  
		void eraseDataFromLineEdit();
		bool isConstantTableEmpty(); 
		virtual ~ConstantWindow();

	protected :
                void closeEvent(QCloseEvent *event);                
	
	public slots :        /*!< Functions called after a click. */
		void callConstantHelp();
		void addRowInTable();
		void deleteRow() ;
		void saveData();

	signals :
		
		void rowIsAdded();
		void rowIsDeleted(QString choix);
		void windowIsClosed(int anInt);

	private:
		
		QTimer *m_constantTimer;
		yao::Table <yao::Constant> *m_localConstantTable;
		yao::Constant *m_localConstant;
		std::vector <std::string> *localHeaderList;
	
                QStringListModel *m_modeleListeNoms;
                QStringList m_savedData;

		QStandardItemModel *m_defvalModel;
		QModelIndex index;
		MainWindowController *localMwc;
		//ConstantWindowController *localConstantController;
		HatNameWindow *localHatWindow;
};
#endif
