#ifndef HATNAME_HPP
#define HATNAME_HPP

#include <QVBoxLayout>
#include <QPushButton>
#include <QFormLayout>
#include <QLineEdit>
#include <QListView>
#include <QStandardItemModel>
#include <QMessageBox>
#include <QCloseEvent>
#include <QFileDialog>
#include <QLabel>
#include <QStringListModel>
#include <QComboBox>
#include <QStringList>
#include <QSpacerItem>
#include <string>
#include <QGridLayout>

#include "../../../help/FilePath.hpp"
#include "../../../YAOObjects/Constant.hpp"
#include "../../../YAOObjects/Table.hpp"


/*!
 * \class HatNameWindow
 * \brief HatNameWindow class for visual_YAO.
 */


class HatNameWindow : public QWidget {

        Q_OBJECT;

        public :
            /*!
             *  \brief Constructor
             *
             *  Constructor of the class HatNameWindow
             *
             *  \param vector<string> * theHeaderList;
             */

		HatNameWindow(std::vector <std::string> *aHeaderList, yao::Table <yao::Constant> *aConstantTable, QWidget *parent = 0);
		void setNomFichierHat(QString nomFichierHat);                       /*!< This function sets the file's name. */
		std::string getNomFichierHat();                                         /*!< This function returns the fil's name */
		QStringList getHatName();
		void setLocalProjectName(std::string name);
		bool isHeaderListEmpty();
		std::string getLocalProjectName();
		~HatNameWindow();

            /*!
             *  \brief SLOT functions
             *
             *  SLOTS are (for examples) functions called after a signal emited.
             *
             *  \param vector<string> * theHeaderList;
             */

        public slots :

                void addHatRow();               /*!< This function is called to insert data in the model. */
                void deleteARow(string aString = "");            /*!< This function is called to delete data from the model. */
                void deleteHatRow();            /*!< This function is called to delete data from the model. */
                void toInitialize();       /*!< This function is called to initialize the lineEdit. */
                void ouvrirProjetExistant();    /*!< This function is called to open an existing project. */
                void appelEnregistrer();        /*!< This function is called to save the current project in the file model */
                void setFileList(std::string localString);
                void setTheHeaderList(std::vector<std::string> *theHeaderList);

                //void setTheHeaderList(std::string theHeaderList);
                std::vector<std::string> * getTheHeaderList();
                QStringList getHatList();
                void callHatHelp();
	signals :
			
		void hatWindowIsClosed(int anInt);
		void test();
            /*!
             *  \brief private functions
             *
             *  SLOTS are (for examples) functions called after a signal emited.
             *
             *  \param vector<string> * theHeaderList;
             */

	protected :

		void closeEvent(QCloseEvent *event);


       private :

                QLabel *m_texte;
		QLabel *m_labelNom1HatName;
		QLabel *m_labelNom2HatName;
        
                QComboBox *m_comboHatName;

                QPushButton *m_boutonouvrir;
                QPushButton *m_enregHatName;
                QPushButton *m_delHatButton;
                QPushButton *m_quitHatName;
                QPushButton *m_boutonAjouter;
                QPushButton *m_hatnameHelpButton;

                QFormLayout *m_layout1HatName;
                QSpacerItem *m_spacer;

                QHBoxLayout *m_layoutH1HatName;
                QHBoxLayout *m_layoutH2HatName;
                QHBoxLayout *m_layoutH3HatName;
                QVBoxLayout *m_layoutV1HatName;
		
		QGridLayout *m_layoutGHatName;		

                QStringList listeFichiers;
                QStringListModel *modeleFichiers;
        	QListView *hatView;

                QStandardItemModel *m_hatnameModel;

                QFileDialog *boiteDialogue;
                QModelIndex index;
                QString cheminFichier;
                std::string extension;
                std::string hatFile;
                std::vector<std::string> *localHeaderList;
                std::string localProjectName;
		yao::Table <yao::Constant> *localConstantTable;
};
#endif
