/*!
 * \file    InsertFCTWindow.hpp
 * \brief   InsertFCT class for visual_YAO.
 * \version 2010/06/16 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane.
 */

#ifndef INSERTFCT_HPP
#define INSERTFCT_HPP

#include "../../ui_insertfctwindow.h"
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Function.hpp"
#include <QStandardItemModel>
#include <QMessageBox>
#include <QMessageBox>
#include <sstream>

class InsertFCTWindow : public QWidget, public Ui::InsertFCTWindow {

    Q_OBJECT

	public :
            InsertFCTWindow(yao::Table <yao::Function>  *aFunctionTable , QWidget *parent=0); /*!< Constructeur */
            //void initialiserChampsfct();
            

	public slots:         /*!< Functions called after a click. */
		void callInsertFCTHelp();	
		void deleteRowFCT();
		void addInsertRow();

	signals:
		void insertFCTWindowIsClosed(int );

	
	protected:
		void closeEvent(QCloseEvent *event);
            
	private :	
		QStandardItemModel *m_insertFCTModel;
		QModelIndex index;
		yao::Table <yao::Function>  *localFunctionTable;

};

#endif // INSERTFCT_HPP
