/*
  Nom du Fichier: InstructionWindow.hpp
  Nom de classe: InstructionWindow
  Role:
  Functions:
  Attributs:
  */

#ifndef INSTRUCTIONWINDOW_HPP
#define INSTRUCTIONWINDOW_HPP
#include <QStandardItemModel> 
#include <QModelIndex> 
#include <QMessageBox> 
#include "../../ui_instructionwindow.h"
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Function.hpp"

//#include "InsertFCTWindow.hpp"

class InstructionWindow: public QWidget, public Ui::InstructionWindow {

	Q_OBJECT

	public :
		InstructionWindow(std::vector <std::string> *anInstructionData, yao::Table <yao::Function> *aFunctionTable, QWidget *parent=0);
		QStringList getInstruction(); 

	private slots:
		void addInstructionRow();	
		void selectedFunction(QModelIndex index);
		
	signals:
		void activeTheIAction();
		//void orderWindowIsClosed(int );

	//protected:
		//void closeEvent(QCloseEvent *event);

	private :
		QStandardItemModel *m_instructionLeftModel;
		QStandardItemModel *m_instructionRightModel;
		QStandardItem *initialisation;
		QStandardItem *minimisation; 
		QStandardItem *input_output; 
		QStandardItem *test; 
		QStandardItem *execution; 
		QStandardItem *user_functions; 
		
		QStringList savedData;
		std::vector <std::string> *m_localInstructionData;
		yao::Table <yao::Function> *localFunctionTable;
		 //QStandardItemModel *m_orderModel;
};
#endif // INSTRUCTIONWINDOW_HPP
