/*
  Nom du Fichier: ModinspaceWindow.hpp
  Nom de classe: ModinspaceWindow
  Role:
  Functions:
  Attributs:
  */

#ifndef MODINSPACEWINDOW_HPP
#define MODINSPACEWINDOW_HPP
#include <QStandardItemModel> 
#include <QMessageBox> 
#include <vector>
#include "../../ui_modinspace.h"
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Operator.hpp"
#include "../../../YAOObjects/Modul.hpp"
#include "../../../YAOObjects/Order.hpp"

class QModelIndex; 


class ModinspaceWindow: public QWidget, public Ui::ModinspaceWindow {

	Q_OBJECT

	public :
		ModinspaceWindow(yao::Table <yao::Modul> *aModulTable, yao::Table <yao::Space> *aSpaceTable, yao::Table <yao::Operator> *anOperatorTable, yao::Table <yao::Order> *anOrderTable, yao::Order *anOrder, std::vector <std::string> *anOrderTokens, QWidget *parent=0);
		
		std::vector <std::string> getTokens() { return *m_localOrderTokens; }

	private slots:
		//void addInstructionRow();	
		//void selectedFunction(QModelIndex index);
		void addTheAxesRow(); 
		void addTheModulRow(); 
		void deleteAxesRow(); 
		void deleteModulRow(); 
		void addBlockEndRow(int anInt); 
		void addOrder(); 
		void addFOrder(); 
	//	void addEndRow(bool aBool); 
	
	signals:
		//void orderWindowIsClosed(int );

	//protected:
		//void closeEvent(QCloseEvent *event);

	private :
		yao::Table <yao::Modul> *m_localModulTable;
                yao::Table <yao::Space> *m_localSpaceTable;
                yao::Table <yao::Operator> *m_localOperaTable;
                yao::Table <yao::Order> *m_localOrderTable;
                yao::Order *m_localOrder;
		
		QStandardItemModel *m_axesModel;
		QStandardItemModel *m_modulNameModel;
		QStandardItemModel *m_outlineModel;
		
		QModelIndex indexForAxes; 
		QModelIndex indexForModul; 
		
		std::vector <std::string> *m_theLocalAxesTable;
		std::vector <std::string> *m_theLocalModulTable;
		std::string commonName;//Can be the spacename or operaname
		std::vector <std::string> m_localOrderTokens2;
		std::vector <std::string> *m_localOrderTokens;
		int orderCounter;	
		int forderCounter;	
};
#endif // MODINSPACEWINDOW_HPP
