/*!
 * \file    Netwardwindow.hpp
 * \brief   Netward class for visual_YAO.
 * \version 2010/06/22 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane.
 */


#ifndef NETWARD_HPP
#define NETWARD_HPP
#include "../../../YAOObjects/Constant.hpp"
#include "../../../YAOObjects/Constant.hpp"
#include "../../../YAOObjects/Neuron.hpp"
#include "../../../YAOObjects/Table.hpp"
#include "../../ui_netwardwindow.h"
#include <QMessageBox>
#include <QTextStream>
#include <QModelIndex>
#include <QStandardItemModel>

class NetwardWindow : public QWidget, Ui::NetwardWindow {

           Q_OBJECT;

    public :
              /*!
             *  \brief Constructor
             *
             *  Constructor of the class NetwardWindow
             *  
             */
            NetwardWindow(yao::Table <yao::Neuron> *aNeuronTable, yao::Table <yao::Constant> *aConstantTable, QWidget *parent=0);  /*!< This function sets the file's name. */
            
            //--void addRowNetward();
		void toInitialize();
		const int toInt(const std::string& s);
      
	public slots :                       /*!< Functions called after a click. */
		
		void addNetwardRow();    /*!< This function is called to add row in the visual window model. */
                void deleteNetwardRow();  /*!< This function is called to delete row from the Yao model. */
                void callNetwardHelp();  /*!< This function is called to help of this directive.*/

	signals:
		void netwardWindowIsClosed(int anInt);
		
	protected:
		void closeEvent(QCloseEvent *event);	
	
	private :

		QModelIndex index1;
		QStandardItemModel *m_netwardModel;
		
		yao::Table <yao::Constant> *m_localConstantTable;  /*!< This function sets the file's name. */
		yao::Table <yao::Neuron> *m_localNeuronTable;  /*!< This function sets the file's name. */

};
#endif // NETWARDWINDOW_HPP
