/*
  Nom du Fichier: SpaceintrajWindow.hpp
  Nom de classe: SpaceintrajWindow
  Role:
  Functions:
  Attributs:
  */

#ifndef SPACEINTRAJWINDOW_HPP
#define SPACEINTRAJWINDOW_HPP
#include <QStandardItemModel> 
#include "../../ui_spaceintraj.h"
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Operator.hpp"
#include "../../../YAOObjects/Trajectory.hpp"
#include "../../../YAOObjects/Order.hpp"

class QModelIndex; 
class QMessageBox; 

class SpaceintrajWindow: public QWidget, public Ui::SpaceintrajWindow {

	Q_OBJECT

	public :
		SpaceintrajWindow(yao::Table <yao::Trajectory> *aTrajectoryTable, yao::Table <yao::Space> *aSpaceTable, yao::Table <yao::Operator> *anOperatorTable, yao::Table <yao::Order> *anOrderTable, yao::Order *anOrder, std::vector <std::string> *anOrderTokens, QWidget *parent=0);

	private slots:
		void addFOrder(int anInt);
		void addSpaceNameInListView();	
		//void addTheEnd();	
		//void selectedFunction(QModelIndex index);
		
	signals:
		//void orderWindowIsClosed(int );
		void theEndSignal(bool aBool);

	//protected:
		//void closeEvent(QCloseEvent *event);

	private :

		yao::Table <yao::Trajectory> *m_trajectoryTable;
                yao::Table <yao::Space> *m_spaceTable;
                yao::Table <yao::Operator> *m_operatorTable;
		QStandardItemModel *m_spaceOrOperanameModel;
		QStandardItemModel *m_outlineModel2;
		yao::Order *m_localOrder;
		std::vector <std::string> *m_localOrderTokens;
		yao::Table <yao::Order> *m_localOrderTable;
};
#endif // SPACEINTRAJWINDOW_HPP
